clear all
close all
clc

% Dati del sistema
m=1;
M=10;
g=9.8;
l=1;

% Matrici del sistema linearizzato
A=[0,1,0,0;0,0,-m/M*g,0;0,0,0,1;0,0,g/l*(M+m)/M,0];
B=[0,0;1/M,-1/(l*M);0,0;-1/(M*l),1/l^2*(M+m)/(M*m)];
C=[1,0,0,0;0,0,1,0];
D=zeros(2);

% Verifica raggiungibilit/osservabilit
det(ctrb(A,B(:,1)))
det(ctrb(A,B(:,2)))
det(obsv(A,C(1,:)))
det(obsv(A,C(2,:)))

% Assegnamento degli autovalori
p=conv([1 1.5 1],[1 2 1]);
K=-place(A,B(:,1),roots(p));
%roots(p)
%eig(A+B(:,1)*K)

% Assegnamento autovalori ricostruttore
pobs=conv([1 15 100],[1 20 100]);
L=-place(A',C(1,:)',roots(pobs))';
%roots(pobs)
%eig(A'+C(1,:)'*L')

% Assegnamento autovalori con regolazione a zero dell'errore
Ktot=-place([A,zeros(4,1);-C(1,:),0],[B(:,1);0],[roots(p); -2]);
K=Ktot(1:4);ki=Ktot(5);
